#*********************************************************************
#*** ResourcePool::Command
#*** Copyright (c) 2002 by Markus Winand <mws@fatalmind.com>
#*** $Id: Command.pm,v 1.4 2003/01/04 11:20:30 mws Exp $
#*********************************************************************
package ResourcePool::Command;

use vars qw($VERSION);
$VERSION = "1.0000";

sub execute($$@) {
	my ($self, $command, @addargs) = @_;
	my $try = $self->{MaxExecTry};
	my $rc ;

	do {
		my $plain_rec = $self->get();
		$rc = 0;
		if (defined $plain_rec) {
			eval {
				$rc = $command->execute($plain_rec, @addargs);
			};
			if ($@) {
				warn('ResourcePool::Command->execute() failed: ' . $@);
				$self->fail($plain_rec);
			} else {
				$self->free($plain_rec);
			}
		}
	} while ($@ && ($try-- > 0));
	if ($@) {
		die $@ . "\n";
	}
	return $rc;
}
1;
