#*********************************************************************
#*** ResourcePool::Factory::Wrap
#*** Copyright (c) 2002 by Markus Winand <mws@fatalmind.com>
#*** $Id: Wrap.pm,v 1.3 2003/01/04 11:20:31 mws Exp $
#*********************************************************************

package ResourcePool::Factory::Wrap;

use strict;
use ResourcePool::Factory;
use vars qw($VERSION @ISA);

push @ISA, "ResourcePool::Singleton";
$VERSION = "1.0000";

sub new($$) {
	my $proto = shift;
	my $class = ref($proto) || $proto;
	my $fact = shift;
	my $self = {};
	$self->{fact} = $fact->singleton();

	bless($self, $class);

	return $self;
}

#sub create_resource($) {
#	my ($self) = @_;
#	return $self->{fact}->create_resource();
#}

sub info($) {
	my ($self) = @_;
	return $self->{fact}->info();
}

sub singleton($) {
	my ($self) = @_;
	my $singleton = $self->SUPER::new($self->mk_singleton_key());

	if (!$singleton->{initialized}) {
		%{$singleton} = %{$self};
		$singleton->{initialized} = 1;
	}
	return $singleton;
}


sub mk_singleton_key($) {
	my $d = Data::Dumper->new([$_[0]]);
	$d->Indent(0);
	$d->Terse(1);
	return $d->Dump();
}


sub _my_very_private_and_secret_test_hook($) {
	my ($not_self) = @_;
	my $self = $not_self->singleton();	
	return $self->{Used};
}

sub _my_very_private_and_secret_test_hook2($$) {
	my ($not_self, $mode) = @_;
	my $self = $not_self->singleton();	
	$self->{VALID} = $mode;
}

1;
