#! /usr/bin/perl -w
#*********************************************************************
#*** t/09Wrap.t
#*** Copyright (c) 2002 by Markus Winand <mws@fatalmind.com>
#*** $Id: 09Wrap.t,v 1.1 2002/12/19 19:41:31 mws Exp $
#*********************************************************************
use strict;

use Test;
use ResourcePool;
use ResourcePool::Factory;
use ResourcePool::Factory::Wrap::NoPreCheck;
use ResourcePool::Factory::Wrap::NoPostCheck;
use ResourcePool::Factory::Wrap::NoChecks;

BEGIN { plan tests => 5; };

# there shall be silence
$SIG{'__WARN__'} = sub {};


my $f = ResourcePool::Factory->new('f1');
my $r1 = $f->create_resource();

# first check the plain Factory
ok ($r1->precheck() && $r1->postcheck());
$r1->_my_very_private_and_secret_test_hook(0);
ok (!$r1->precheck() && !$r1->postcheck());

my $f1;

$f1 = ResourcePool::Factory::Wrap::NoPreCheck->new($f);
$r1 = $f1->create_resource();
$r1->_my_very_private_and_secret_test_hook(0);
ok ($r1->precheck() && ! $r1->postcheck());

$f1 = ResourcePool::Factory::Wrap::NoPostCheck->new($f);
$r1 = $f1->create_resource();
$r1->_my_very_private_and_secret_test_hook(0);
ok (!$r1->precheck() && $r1->postcheck());

$f1 = ResourcePool::Factory::Wrap::NoChecks->new($f);
$r1 = $f1->create_resource();
$r1->_my_very_private_and_secret_test_hook(0);
ok ($r1->precheck() && $r1->postcheck());

