#! /usr/bin/perl -w
#*********************************************************************
#*** t/12PoolExecute.t
#*** Copyright (c) 2002 by Markus Winand <mws@fatalmind.com>
#*** $Id: 12PoolExecute.t,v 1.2 2003/01/04 11:20:31 mws Exp $
#*********************************************************************
use strict;

use Test;
use ResourcePool;
use ResourcePool::Factory;

package MyTestCommandOK;

sub new($$) {
	my $proto = shift;
	my $class = ref($proto) || $proto;
	my $self = {};
	bless($self, $class);

	$self->setCalled(0);
	return $self;
}

sub execute($$) {
	my ($self, $resource) = @_;
	$self->setCalled($self->getCalled()+1);
	return 1;
}

# i start to like get/set methods for perl, because they enable
# compiletime checking of typos
sub setCalled($$) {
	my ($self, $val) = @_;
	$self->{called} = $val;
}

sub getCalled($) {
	my ($self) = @_;
	return $self->{called};
}

package MyTestCommandReturnFalse;

push @MyTestCommandReturnFalse::ISA, qw(MyTestCommandOK);

sub execute($$) {
	my ($self, @args) = @_;
	$self->SUPER::execute(@args);
	return 0;
}

package MyTestCommandReturnArgument;

push @MyTestCommandReturnArgument::ISA, qw(MyTestCommandOK);

sub execute($$$) {
	my ($self, $resource, $arg) = @_;
	$self->SUPER::execute($resource);
	return $arg;
}

package MyTestCommandDie;

push @MyTestCommandDie::ISA, qw(MyTestCommandOK);

sub execute($$) {
	my ($self, @args) = @_;
	$self->SUPER::execute(@args);
	die;
}

package main;


#BEGIN { plan tests => 11; };

# there shall be silence
$SIG{'__WARN__'} = sub {};


#my $f1 = ResourcePool::Factory->new('f1');
#my $p1 = ResourcePool->new($f1, MaxExecTry => 4);
#my ($cmd, $rc);
#
#$cmd = new MyTestCommandOK();
#$rc = $p1->execute($cmd);
#ok ($rc == 1);
#ok ($cmd->getCalled() == 1);
#
#$cmd = new MyTestCommandReturnFalse();
#$rc = $p1->execute($cmd);
#ok ($rc == 0);
#ok ($cmd->getCalled() == 1);
#
#$cmd = new MyTestCommandDie();
#$rc = $p1->execute($cmd);
#ok ($rc == 0);
#ok ($cmd->getCalled() == 4);
#
#
#$cmd = new MyTestCommandReturnArgument();
#$rc = $p1->execute($cmd, 'elch');
#ok ($rc eq 'elch');
#ok ($cmd->getCalled() == 1);
#
#$rc = $p1->execute($cmd, 'hirsch');
#ok ($rc eq 'hirsch');
#ok ($cmd->getCalled() == 2);
#
#$rc = ResourcePool::Command::execute($p1, $cmd, 'reh');
#ok ($rc eq 'reh');
